clang 8.0.0

Public Types | Public Member Functions | List of all members
clang::sema::AccessedEntity Class Reference

A declaration being accessed, together with information about how it was accessed. More...

`#include "clang/Sema/DelayedDiagnostic.h"`

## Public Types
enum | MemberNonce { Member }
| A member declaration found through lookup. More...
enum | BaseNonce { Base }
| A hierarchy (base-to-derived or derived-to-base) conversion. More...

## Public Member Functions
| AccessedEntity (PartialDiagnostic::StorageAllocator &Allocator, MemberNonce _, CXXRecordDecl *NamingClass, DeclAccessPair FoundDecl, QualType BaseObjectType)
| AccessedEntity (PartialDiagnostic::StorageAllocator &Allocator, BaseNonce _, CXXRecordDecl *BaseClass, CXXRecordDecl *DerivedClass, AccessSpecifier Access)
bool | isMemberAccess () const
bool | isQuiet () const
AccessSpecifier | getAccess () const
NamedDecl * | getTargetDecl () const
CXXRecordDecl * | getNamingClass () const
CXXRecordDecl * | getBaseClass () const
CXXRecordDecl * | getDerivedClass () const
QualType | getBaseObjectType () const
| Retrieves the base object type, important when accessing an instance member. More...
void | setDiag (const PartialDiagnostic &PDiag)
| Sets a diagnostic to be performed. More...
PartialDiagnostic & | setDiag (unsigned DiagID)
const PartialDiagnostic & | getDiag () const

## Detailed Description

A declaration being accessed, together with information about how it was accessed.

Definition at line 51 of file DelayedDiagnostic.h.

## Member Enumeration Documentation

## ◆ BaseNonce

enum clang::sema::AccessedEntity::BaseNonce

A hierarchy (base-to-derived or derived-to-base) conversion.

The target is the base class.

Enumerator
Base |

Definition at line 59 of file DelayedDiagnostic.h.

## ◆ MemberNonce

enum clang::sema::AccessedEntity::MemberNonce

A member declaration found through lookup.

The target is the member.

Enumerator
Member |

Definition at line 55 of file DelayedDiagnostic.h.

## Constructor & Destructor Documentation

## ◆ AccessedEntity() [1/2]

clang::sema::AccessedEntity::AccessedEntity | ( | PartialDiagnostic::StorageAllocator & | Allocator,
|  | MemberNonce | _,
|  | CXXRecordDecl * | NamingClass,
|  | DeclAccessPair | FoundDecl,
|  | QualType | BaseObjectType
| ) |  |
| inline

Definition at line 61 of file DelayedDiagnostic.h.

Referenced by clang::sema::DelayedDiagnostic::makeAccess().

## ◆ AccessedEntity() [2/2]

clang::sema::AccessedEntity::AccessedEntity | ( | PartialDiagnostic::StorageAllocator & | Allocator,
|  | BaseNonce | _,
|  | CXXRecordDecl * | BaseClass,
|  | CXXRecordDecl * | DerivedClass,
|  | AccessSpecifier | Access
| ) |  |
| inline

Definition at line 71 of file DelayedDiagnostic.h.

## Member Function Documentation

## ◆ getAccess()

AccessSpecifier clang::sema::AccessedEntity::getAccess | ( |  | ) | const
| inline

Definition at line 83 of file DelayedDiagnostic.h.

## ◆ getBaseClass()

CXXRecordDecl* clang::sema::AccessedEntity::getBaseClass | ( |  | ) | const
| inline

Definition at line 90 of file DelayedDiagnostic.h.

## ◆ getBaseObjectType()

QualType clang::sema::AccessedEntity::getBaseObjectType | ( |  | ) | const
| inline

Retrieves the base object type, important when accessing an instance member.

Definition at line 97 of file DelayedDiagnostic.h.

## ◆ getDerivedClass()

CXXRecordDecl* clang::sema::AccessedEntity::getDerivedClass | ( |  | ) | const
| inline

Definition at line 93 of file DelayedDiagnostic.h.

## ◆ getDiag()

const PartialDiagnostic& clang::sema::AccessedEntity::getDiag | ( |  | ) | const
| inline

Definition at line 115 of file DelayedDiagnostic.h.

## ◆ getNamingClass()

CXXRecordDecl* clang::sema::AccessedEntity::getNamingClass | ( |  | ) | const
| inline

Definition at line 87 of file DelayedDiagnostic.h.

## ◆ getTargetDecl()

NamedDecl* clang::sema::AccessedEntity::getTargetDecl | ( |  | ) | const
| inline

Definition at line 86 of file DelayedDiagnostic.h.

## ◆ isMemberAccess()

bool clang::sema::AccessedEntity::isMemberAccess | ( |  | ) | const
| inline

Definition at line 79 of file DelayedDiagnostic.h.

## ◆ isQuiet()

bool clang::sema::AccessedEntity::isQuiet | ( |  | ) | const
| inline

Definition at line 81 of file DelayedDiagnostic.h.

References clang::PartialDiagnostic::getDiagID().

Referenced by setDiag().

## ◆ setDiag() [1/2]

void clang::sema::AccessedEntity::setDiag | ( | const PartialDiagnostic & | PDiag | ) |
| inline

Sets a diagnostic to be performed.

The diagnostic is given four (additional) arguments: %0 - 0 if the entity was private, 1 if protected %1 - the DeclarationName of the entity %2 - the TypeDecl type of the naming class %3 - the TypeDecl type of the declaring class

Definition at line 105 of file DelayedDiagnostic.h.

References isQuiet().

## ◆ setDiag() [2/2]

PartialDiagnostic& clang::sema::AccessedEntity::setDiag | ( | unsigned | DiagID | ) |
| inline

Definition at line 109 of file DelayedDiagnostic.h.

References isQuiet(), and clang::PartialDiagnostic::Reset().

The documentation for this class was generated from the following file:

- include/clang/Sema/DelayedDiagnostic.h